version: '3.8'
services:
  tangodb:
    image: harbor.skao.int/production/ska-tango-images-tango-db:10.4.16
    container_name: tangodb_tdb
    network_mode: ${NETWORK_MODE}
    ports:
    - "${TANGODB_PORT}:3306"
    environment:
    - MYSQL_ROOT_PASSWORD=secret
    - MYSQL_DATABASE=tango
    - MYSQL_USER=tango
    - MYSQL_PASSWORD=tango
    logging:
      driver: "none"
    restart: on-failure

  databaseds:
    image: harbor.skao.int/production/ska-tango-images-tango-cpp:9.3.11
    container_name: databaseds_tdb
    network_mode: ${NETWORK_MODE}
    ports:
    - "10000:10000"
    depends_on:
    - tangodb
    environment:
    - MYSQL_HOST=${TANGODB_HOST}:${TANGODB_PORT}
    - MYSQL_DATABASE=tango
    - MYSQL_USER=tango
    - MYSQL_PASSWORD=tango
    - TANGO_HOST=${TANGO_HOST}
    logging:
      driver: "none"
#    entrypoint:
#    - /usr/local/bin/wait-for-it.sh ${TANGODB_HOST}:${TANGODB_PORT} --timeout=30 --strict--
#    - /usr/local/bin/DataBaseds "2" -ORBendPoint giop:tcp::10000
    command:
      sh -c "sleep 30 && /usr/local/bin/wait-for-it.sh ${TANGODB_HOST}:${TANGODB_PORT} --timeout=30 --strict --
             sleep 10 && /usr/local/bin/DataBaseds "2" -ORBendPoint giop:tcp::10000"
    restart: always

  dsconfig:
    image: harbor.skao.int/production/ska-tango-images-tango-dsconfig:1.5.5
    container_name: dsconfig_tdb
    network_mode: ${NETWORK_MODE}
    depends_on:
      - databaseds
    environment:
      - TANGO_HOST=${TANGO_HOST}
    command: >
      sh -c "sleep 30 && wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
             sleep 10 && json2tango -w -a -u /hdbpp-conf/hdbpp_timescaledb.json &&
             sleep infinity"
    volumes:
      - ../../conf:/hdbpp-conf
#    restart: on-failure

  hdbpp-timescaledb:
    image: hdbpp-timescale:latest
    container_name: hdbpp-timescaledb
    network_mode: ${NETWORK_MODE}
    volumes:
    - /posql-data/hdbpp-timescaledb-data:/var/lib/postgresql/data
#     - hdbpp-timescaledb-data:/var/lib/postgresql/data
    ports:
    - "5432:5432"
    environment:
    - POSTGRES_PASSWORD=hdbpp
    command: -c synchronous_commit=off
#      --postgres -c synchronous_commit='off'
#      --"postgres -c max_wal_size=2GB"


  hdbpp-cm:
    image: tango-hdbpp:latest
    container_name: hdbpp-cm_tdb
    network_mode: ${NETWORK_MODE}
    environment:
    - TANGO_HOST=${TANGO_HOST}
    depends_on:
    - databaseds
    - dsconfig
    - hdbpp-timescaledb
    command: >
      /bin/bash -c "sleep 35 && 
        wait-for-it.sh ${HDBPP_HOST} --timeout=300 --strict --
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && hdbppcm-srv 01"

  hdbpp-es:
    image: tango-hdbpp:latest
    container_name: hdbpp-es_tdb
    network_mode: ${NETWORK_MODE}
    environment:
    - TANGO_HOST=${TANGO_HOST}
    depends_on:
    - databaseds
    - dsconfig
    - hdbpp-timescaledb
    - evgen
    logging:
      driver: "none"
    command: >
      /bin/bash -c "sleep 35 &&
        wait-for-it.sh ${HDBPP_HOST} --timeout=300 --strict --
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && hdbppes-srv 01"
  hdbpp-es2:
    image: tango-hdbpp:latest
    container_name: hdbpp-es_tdb2
    network_mode: ${NETWORK_MODE}
    environment:
    - TANGO_HOST=${TANGO_HOST}
    depends_on:
    - databaseds
    - dsconfig
    - hdbpp-timescaledb
    - evgen
    logging:
      driver: "none"
    command: >
        /bin/bash -c "sleep 35 &&
        wait-for-it.sh ${HDBPP_HOST} --timeout=300 --strict --
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && hdbppes-srv 02"


  evgen:
    image: tango-evgen:latest
    container_name: evgen_tdb
    network_mode: ${NETWORK_MODE}
    environment:
    - TANGO_HOST=${TANGO_HOST}
    depends_on:
    - databaseds
    - dsconfig
    command: >
      /bin/bash -c "sleep 35 &&
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && evgen-srv 01"

  evgen2:
    image: tango-evgen:latest
    container_name: evgen_tdb2
    network_mode: ${NETWORK_MODE}
    environment:
    - TANGO_HOST=${TANGO_HOST}
    depends_on:
    - databaseds
    - dsconfig
    command: >
      /bin/bash -c "sleep 35 &&
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && evgen-srv 02"

  hdbppconfig:
    image: tango-hdbppconfig:latest
    container_name: hdbppconfig_tdb
    network_mode: ${NETWORK_MODE}
    depends_on:
      - evgen
      - evgen2
      - hdbpp-es
      - hdbpp-es2
      - hdbpp-cm
    environment:
      - TANGO_HOST=${TANGO_HOST}
      - "PYTHONUNBUFFERED=1"

    command: >
      sh -c "sleep 40 &&
        wait-for-it.sh ${HDBPP_HOST} --timeout=300 --strict --
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && /usr/src/app/hdbppconfig.py --device=archiving/hdbppmanager/0 --archiver=archiving/hdbppsubscriber/0 --file=/hdbpp-conf/hdbpp_evgen.conf &&
        sleep 10 && /usr/src/app/hdbppconfig.py --device=archiving/hdbppmanager/0 --archiver=archiving/hdbppsubscriber/1 --file=/hdbpp-conf/hdbpp_evgen2.conf &&
      sleep infinity"
    volumes:
      - ../../conf:/hdbpp-conf
#    restart: on-failure

  hdbpp-test-insertion:
    image: hdbpp-test-insertion:latest
    container_name: hdbpp-test-insertion_tdb
    network_mode: ${NETWORK_MODE}
    depends_on:
      - evgen
      - hdbpp-es
      - hdbpp-cm
      - hdbppconfig
    environment:
      - TANGO_HOST=${TANGO_HOST}
      - "PYTHONUNBUFFERED=1"
    command: >
      sh -c "sleep 250 &&
        wait-for-it.sh ${HDBPP_HOST} --timeout=300 --strict --
        wait-for-it.sh ${TANGO_HOST} --timeout=300 --strict --
        sleep 10 && /usr/src/app/hdbpp-test-insertion.py --type long --scalartype scalar --rwtype ro --archiver archiving/hdbppsubscriber/ --archivernum 2 --evgen archiving/evgen/ --evgennum 20 --period 10000 --number 5000 --file /hdbpp-conf/hdbpp_timescaledb &&
        sleep infinity"
    volumes:
      - ../../conf:/hdbpp-conf
      - /var/run/docker.sock:/var/run/docker.sock
      - /posql-data/hdbpp-timescaledb-data:/data
#    restart: on-failure

volumes:
    hdbpp-timescaledb-data:
      driver: local
      driver_opts:
        o: bind
        type: none
        device: /posql-data/hdbpp-timescaledb-data
